
PROGRAM LPJJGLOS;

(* VERSION 2.00 POUR WINDOWS 32 BITS.

   DATE DE CREATION : 10-03-2002.
   DERNIERE MISE A JOUR : 12-05-2005.

   OUTIL DE GESTION DU GLOSSAIRE DE MACROS POUR LE PROGRAMME LPJJHELP 2.00.

   IL S'AGIT DE LA VERSION 32 BITS DU PROGRAMME LPJJGLOS 1.00 :
   - LE SOURCE BPW 7.0 A ETE RECOMPILE AVEC VIRTUAL PASCAL 2.1,
   - LES RESSOURCES ONT ETE RECOMPILEES AVEC RESOURCE BUILDER 2.00.

   PRINCIPALES MODIFICATIONS POUR LE PORTAGE 32 BITS :
   - DANS LE FORMAT DES DONNEES STOCKEES SUR FICHIER, LE TYPE WORD A ETE REMPLACE PAR SMALLWORD,
   - LA FONCTION API GetTextExtent (NON SUPPORTEE PAR L'API 32 BITS) EST REMPLACEE PAR GetTextExtentPoint.

   CE PROGRAMME REPREND L'ENSEMBLE DES FONCTIONNALITES DE GESTION DE FICHIER :
   - GESTION DE BAS NIVEAU CONFIEE AUX FONCTIONS DU KERNEL WINDOWS,
   - OUVERTURE DE FICHIER,
   - ENREGISTREMENT DE FICHIER,
   - ENREGISTRER SOUS...,
   - GESTION D'UNE LISTE DES DERNIERS FICHIERS OUVERTS (AU BAS DU MENU Fichier),
   - GESTION DU GLISSER-DEPOSER DEPUIS LE GESTIONNAIRE DE FICHIERS,
   - ACCEPTE UN NOM DE FICHIER COMME PARAMETRE DE LANCEMENT.

   CE PROGRAMME REPREND EGALEMENT L'ENSEMBLE DES FONCTIONNALITES DE GESTION D'UNE BOITE LISTE PERSONNALISEE :
   - GESTION DES VARIABLES DYNAMIQUES ENTIEREMENT CONFIEE A LA BOITE LISTE,
   - RACCOURCIS CLAVIERS,
   - AJOUT, MODIFICATION ET SUPPRESSION D'ELEMENTS,
   - REPONSE AU DOUBLE-CLIC POUR MODIFICATION,
   - DESSIN DES ELEMENTS PAR LE PROGRAMME.

   STRUCTURE DES DONNEES :
   ENREGISTREMENTS DE TAILLE VARIABLE COMPRENANT :
   - LA SYNTAXE (TEXTE DE LONGUEUR QUELCONQUE),
   - UNE EXPLICATION (TEXTE DE LONGUEUR QUELCONQUE),
   - UNE EXPLICATION DES PARAMETRES (TEXTE DE LONGUEUR QUELCONQUE),
   - UN EXEMPLE (TEXTE DE LONGUEUR QUELCONQUE).

   FORME DES DONNEES :
   - EN MEMOIRE : LORSQUE LE DIALOGUE DE CREATION OU DE MODIFICATION D'ENREGISTREMENT SE TERMINE, LE PROGRAMME CREE
                  4 VARIABLES DYNAMIQUES DE LA TAILLE EXACTE DU TEXTE ET EN CONFIE L'ADRESSE A LA BOITE LISTE.
   - SUR DISQUE : - TAILLE DE LA SYNTAXE (SMALLWORD),
                  - SYNTAXE (TEXTE DE LONGUEUR QUELCONQUE),
                  - TAILLE DES EXPLICATIONS (SMALLWORD),
                  - EXPLICATIONS (TEXTE DE LONGUEUR QUELCONQUE),
                  - TAILLE DES PARAMETRES (SMALLWORD),
                  - PARAMETRES (TEXTE DE LONGUEUR QUELCONQUE),
                  - TAILLE DE L'EXEMPLE (SMALLWORD),
                  - EXEMPLE (TEXTE DE LONGUEUR QUELCONQUE). *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                              DIRECTIVES DE COMPILATION                                                 *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

{&Use32+}
{$DEFINE OWL}
{$DEFINE WINDOWS}
{$DEFINE WIN32}

{$R LPJJGLOS.RES}   (* FICHIER DE RESSOURCES *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                               UNITES ET DLL UTILISEES                                                  *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Uses STRINGS,    (* GESTION DES CHAINES AZT *)
     WINTYPES,   (* STRUCTURES DE DONNEES DE WINDOWS *)
     WINPROCS,   (* INTERFACES AVEC LES ROUTINES WINDOWS (KERNEL, USER ET GDI) *)
     OWINDOWS,   (* OBJETS FENETRES *)
     ODIALOGS,   (* OBJETS DIALOGUES *)
     {
     WIN31,      (* FONCTIONNALITES DE WINDOWS 3.1 *)
     }
     COMMDLG,    (* INTERFACES AVEC LES DIALOGUES COMMUNS DE WINDOWS *)
     SHELLAPI;   (* GESTION DU GLISSER-DEPOSER *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                   CONSTANTES NON TYPEES (DIRECTIVES AU COMPILATEUR)                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

{$I LPJJGLOS.INC}

Const (* NOM DE L'APPLICATION *)
      NomApplication = 'LPJJGlos 2.00';

      (* NOMBRE D'ENTREES DANS LA LISTE DES DERNIERS FICHIERS OUVERTS *)
      NbEntreesListeFichiers = 9;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                   TYPES DE DONNEES                                                     *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Type (* ========== LISTE DES 9 DERNIERS FICHIERS CHARGES ========== *)

     tFichierOuvert = Array [0..260] of Char;
     tListeFichiers = Array [1..NbEntreesListeFichiers] of tFichierOuvert;

     (* ========== DONNEES D'UNE MACRO EN MEMOIRE ========== *)

     pMacro = ^rMacro;
     rMacro = Record
                Syntaxe : pChar;       (* SYNTAXE EXACTE *)
                Utilisation : pChar;   (* EXPLICATION DE L'UTILITE ET DE L'UTILISATION *)
                Parametres : pChar;    (* SIGNIFICATION DES PARAMETRES *)
                Exemples : pChar;      (* EXEMPLE(S) *)
              end;

     (* ========== DIALOGUE DE MODIFICATION/CREATION DES DONNEES D'UNE MACRO ========== *)

     pDlgMacro = ^tDlgMacro;
     tDlgMacro = Object(tDialog)
                   Donnees : pMacro;                   (* ADRESSE DES DONNEES A MODIFIER *)
                   Buffer : Array [0..4096] of Char;   (* BUFFER DE LECTURE DU CONTENU D'UN CONTROLE *)
                   Constructor INIT (FenetreParent : pWindowsObject; p : pMacro);
                      (* INITIALISATION DES CHAMPS *)
                   Procedure SETUPWINDOW; virtual;
                      (* CENTRAGE DU DIALOGUE - INITIALISATION DES CONTROLES ET DU TITRE *)
                   Procedure OK (var Msg : tMessage); virtual id_First + id_Ok;
                      (* TEST ET RENVOI DES DONNEES *)
                 end;

     (* ========== BOITE LISTE DES MACROS ========== *)

     pListeMacros = ^tListeMacros;
     tListeMacros = Object(tListBox)
                      Constructor INIT (FenetreParent : pWindowsObject);
                         (* DEFINITION DU STYLE DE LA BOITE LISTE *)
                    end;

     (* ========== FENETRE PRINCIPALE ========== *)

     pFenetrePrincipale = ^tFenetrePrincipale;
     tFenetrePrincipale = Object(tWindow)
                            Caption : Array [0..280] of Char;      (* TITRE DE LA FENETRE *)
                            ListeFichiers : tListeFichiers;        (* LISTE DES 9 DERNIERS FICHIERS UTILISES *)
                            Separateur : Boolean;                  (* INDIQUE SI SEPARATEUR LISTE DE FICHIERS PRESENT *)
                            ListeMacros : pListeMacros;            (* BOITE LISTE PRINCIPALE *)
                            NomFichier : Array [0..260] of Char;   (* NOM DU FICHIER ACTUELLEMENT CHARGE *)
                            Repertoire : Array [0..260] of Char;   (* REPERTOIRE COURANT *)
                            Chemin : Array [0..260] of Char;       (* CHEMIN COMPLET D'ACCES AU FICHIER *)
                            Modification : Boolean;                (* INDIQUE S'IL Y A EU DES MODIFICATIONS *)
                            Constructor INIT;
                               (* CHARGEMENT DU MENU, INITIALISATION DES CHAMPS, ALLOCATION DES CONTROLES ENFANTS *)
                            Procedure WMCREATE (var Msg : tMessage); virtual wm_First + wm_Create;
                               (* PRISE EN CHARGE DU GLISSER-DEPOSER DE FICHIER *)
                            Procedure GETWINDOWCLASS (var aWndClass : tWndClass); virtual;
                               (* DEFINITION DE L'ICONE DE CLASSE DE LA FENETRE PRINCIPALE *)
                            Procedure AFFICHAGE_TITRE_FENETRE (NomFichierCourant : pChar);
                               (* CONSTRUCTION DU TITRE DE LA FENETRE AVEC LE NOM DU FICHIER COURANT *)
                            Procedure MISE_A_JOUR_MENU_FICHIER;
                               (* MISE A JOUR DE LA LISTE DES FICHIERS PRECEDEMMENT OUVERTS DANS LE MENU Fichier *)
                            Procedure CHARGEMENT_LISTE_FICHIERS;
                               (* AJOUT DE LA LISTE DES 9 DERNIERS FICHIERS UTILISES AU BAS DU MENU Fichier *)
                            Procedure SAUVEGARDE_LISTE_FICHIERS;
                               (* SAUVEGARDE DE LA LISTE DES 9 DERNIERS FICHIERS UTILISES AU BAS DU MENU Fichier *)
                            Procedure AJOUT_LISTE_FICHIERS (NomFichierCourant : pChar);
                               (* INSERTION D'UN NOM DE FICHIER DANS LA LISTE DES DERNIERS FICHIERS UTILISES *)
                            Procedure SETUPWINDOW; virtual;
                               (* CHARGEMENT DU FICHIER PASSE COMME PARAMETRE - AFFICHAGE DE LA FENETRE EN PLEIN ECRAN *)
                            Procedure WMSIZE (var Msg : tMessage); virtual wm_First + wm_Size;
                               (* ADAPTATION DE LA TAILLE DE LA BOITE LISTE A LA ZONE CLIENT DE LA FENETRE *)
                            Procedure WMMEASUREITEM (var Msg : tMessage); virtual wm_First + wm_MeasureItem;
                               (* DETERMINATION DE LA HAUTEUR D'UNE LIGNE DE LA BOITE LISTE *)
                            Procedure WMDRAWITEM (var Msg : tMessage); virtual wm_First + wm_DrawItem;
                               (* DESSIN D'UN ELEMENT DE LA BOITE LISTE *)
                            Procedure WMCOMPAREITEM (var Msg : tMessage); virtual wm_First + wm_CompareItem;
                               (* COMPARAISON DE 2 ELEMENTS DE LA BOITE LISTE EN VUE DU TRI AUTOMATIQUE *)
                            Procedure CMMACROAJOUTER (var Msg : tMessage); virtual cm_First + cm_MacroAjouter;
                               (* AJOUT D'UNE MACRO DANS LA LISTE *)
                            Procedure CMMACROMODIFIER (var Msg : tMessage); virtual cm_First + cm_MacroModifier;
                               (* MODIFICATION DE LA MACRO COURANTE *)
                            Procedure CMMACROSUPPRIMER (var Msg : tMessage); virtual cm_First + cm_MacroSupprimer;
                               (* SUPPRESSION DE LA MACRO COURANTE *)
                            Procedure WMCOMMAND (var Msg : tMessage); virtual wm_First + wm_Command;
                               (* DOUBLE CLIC SUR UN ELEMENT DE LA BOITE LISTE - CHOIX D'UN FICHIER AU BAS DU MENU Fichier *)
                            Procedure WMDELETEITEM (var Msg : tMessage); virtual wm_First + wm_DeleteItem;
                               (* DESTRUCTION D'UNE DONNEE CREEE DANS LA BOITE LISTE *)
                            Function CHARGEMENT_MACROS : Boolean;
                               (* CHARGEMENT DES MACROS DU FICHIER CHOISI DANS LA BOITE LISTE PRINCIPALE *)
                            Function SAUVEGARDE_MACROS (Nb : Word) : Boolean;
                               (* SAUVEGARDE DES MACROS DE LA BOITE LISTE PRINCIPALE DANS UN FICHIER *)
                            Function PREPARATION_NOUVELLES_DONNEES : Boolean;
                               (* SAUVEGARDE EVENTUELLE DES DONNEES EN COURS AVANT REMPLACEMENT PAR DES NOUVELLES DONNEES *)
                            Procedure WMDROPFILES (var Msg : tMessage); virtual wm_First + wm_DropFiles;
                               (* CHARGEMENT D'UN FICHIER DEPOSE SUR LA FENETRE OUVERTE DEPUIS LE GESTIONNAIRE DE FICHIERS *)
                            Procedure CMFICHIERNOUVEAU (var Msg : tMessage); virtual cm_First + cm_FichierNouveau;
                               (* DEBUT DE L'ENCODAGE DES DONNEES D'UN NOUVEAU FICHIER *)
                            Function CMFICHIEROUVRIR (var Msg : tMessage) : Boolean; virtual cm_First + cm_FichierOuvrir;
                               (* DIALOGUE WINDOWS D'OUVERTURE DE FICHIER *)
                            Function CMFICHIERENREGISTRERSOUS (var Msg : tMessage) : Boolean; virtual cm_First +
                                                                                              cm_FichierEnregistrerSous;
                               (* DIALOGUE WINDOWS D'ENREGISTREMENT D'UN NOUVEAU FICHIER *)
                            Function CMFICHIERENREGISTRER (var Msg : tMessage) : Boolean; virtual cm_First +
                                                                                          cm_FichierEnregistrer;
                               (* ENREGISTREMENT DES MACROS DANS UN FICHIER *)
                            Function CANCLOSE : Boolean; virtual;
                               (* CONFIRMATION DE FERMETURE EN CAS DE DONNEES NON SAUVEGARDEES *)
                            Procedure WMDESTROY (var Msg : tMessage); virtual wm_First + wm_Destroy;
                               (* FIN DE LA PRISE EN CHARGE DU GLISSER-DEPOSER DE FICHIER *)
                            Destructor DONE; virtual;
                               (* SAUVEGARDE DE LA LISTE DES DERNIERS FICHIERS UTILISES DANS LE FICHIER LPJJGlos.ini *)
                          end;

     (* ========== PROGRAMME PRINCIPAL ========== *)

     tProgramme = Object(tApplication)
                    Constructor INIT (NomProgramme : pChar);
                       (* REMPLACEMENT DE LA ROUTINE DE GESTION DES ALLOCATIONS DYNAMIQUES *)
                    Procedure INITINSTANCE; virtual;
                       (* CHARGEMENT DE LA TABLE D'ACCELERATEURS *)
                    Procedure INITMAINWINDOW; virtual;
                       (* CHOIX DU TYPE DE LA FENETRE PRINCIPALE DE L'APPLICATION *)
                  end;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  CONSTANTES TYPEES                                                     *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  VARIABLES GLOBALES                                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Var (* PROGRAMME PRINCIPAL *)
    Programme : tProgramme;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                 GESTION DU TAS GLOBAL                                                  *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

{$F+}
Function ERREUR_ALLOCATION (Taille : Word) : Integer;
(* FORCE LES PROCEDURES D'ALLOCATION DE MEMOIRE DYNAMIQUE A RENVOYER Nil SI ERREUR *)
Begin
  ERREUR_ALLOCATION:=1;
End;
{$F-}

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                        ROUTINES DE BASE DE GESTION DES FICHIERS                                        *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Function CREATION_FICHIER (NomFichier : pChar; Mode : Integer; var hFichier : Integer) : Boolean;
(* CREATION D'UN FICHIER (UTILISATION DES FONCTIONS DU KERNEL WINDOWS) *)
Begin
  hFichier:=_lCreat(NomFichier,Mode);
  CREATION_FICHIER:=(hFichier <> -1);
End;

Function OUVERTURE_FICHIER (NomFichier : pChar; Mode : Integer; var hFichier : Integer) : Boolean;
(* OUVERTURE DE FICHIER (UTILISATION DES FONCTIONS DU KERNEL WINDOWS) *)
Begin
  hFichier:=_lOpen(NomFichier,Mode);
  OUVERTURE_FICHIER:=(hFichier <> -1);
End;

Function LECTURE_FICHIER (hFichier : Integer; Buffer : pChar; Taille : Integer) : Integer;
(* LECTURE DE FICHIER (UTILISATION DES FONCTIONS DU KERNEL WINDOWS) *)
Begin
  LECTURE_FICHIER:=_lRead(hFichier,Buffer,Taille);
End;

Function ECRITURE_FICHIER (hFichier : Integer; Buffer : pChar; Taille : Integer) : Integer;
(* ECRITURE DANS UN FICHIER (UTILISATION DES FONCTIONS DU KERNEL WINDOWS) *)
Begin
  ECRITURE_FICHIER:=_lWrite(hFichier,Buffer,Taille);
End;

Function FERMETURE_FICHIER (hFichier : Integer) : Boolean;
(* FERMETURE D'UN FICHIER (UTILISATION DES FONCTIONS DU KERNEL WINDOWS) *)
Begin
  FERMETURE_FICHIER:=(_lClose(hFichier) <> -1);
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                              METHODES DE L'OBJET tDlgMacro                                             *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tDlgMacro.INIT (FenetreParent : pWindowsObject; p : pMacro);
(* INITIALISATION DES CHAMPS *)
Begin
  tDialog.INIT(FenetreParent,pChar(id_DlgMacro));
  Donnees:=p;
  Buffer[0]:=#0;
End;

Procedure tDlgMacro.SETUPWINDOW;
(* CENTRAGE DU DIALOGUE - INITIALISATION DES CONTROLES ET DU TITRE *)
Var r : tRect;                        (* COORDONNEES DE LA FENETRE *)
    l, h : Integer;                   (* LARGEUR ET HAUTEUR DE LA FENETRE *)
    Titre : Array [0..255] of Char;   (* TITRE DU DIALOGUE *)
    FinLibelle : pChar;               (* POINTE SUR LA FIN DU LIBELLE DE LA MACRO *)
Begin
  tDialog.SETUPWINDOW;
  (* CENTRAGE DU DIALOGUE A L'ECRAN *)
  GetWindowRect(hWindow,r);
  with r do
    begin
      l:=Right - Left;
      h:=Bottom - Top;
    end;
  MoveWindow(hWindow,(GetSystemMetrics(sm_CXScreen) - l) div 2,(GetSystemMetrics(sm_CYScreen) - h) div 2,l,h,true);
  (* INITIALISATION DES CONTROLES ET DU TITRE *)
  if Donnees^.Syntaxe <> Nil
     then
       begin
         SendDlgItemMessage(hWindow,id_Syntaxe,wm_SetText,0,LongInt(Donnees^.Syntaxe));
         (* CHARGEMENT DU LIBELLE DE LA MACRO DANS LE TITRE *)
         StrCopy(Buffer,Donnees^.Syntaxe);
         FinLibelle:=StrPos(Buffer,'(');
         if FinLibelle <> Nil
            then
              FinLibelle[0]:=#0;
         StrCopy(Titre,'Donnes de la macro ');
         StrCat(Titre,Buffer);
       end
     else
       StrCopy(Titre,'Nouvelle macro');
  SetWindowText(hWindow,Titre);
  if Donnees^.Utilisation <> Nil
     then
       SendDlgItemMessage(hWindow,id_Utilisation,wm_SetText,0,LongInt(Donnees^.Utilisation));
  if Donnees^.Parametres <> Nil
     then
       SendDlgItemMessage(hWindow,id_Parametres,wm_SetText,0,LongInt(Donnees^.Parametres));
  if Donnees^.Exemples <> Nil
     then
       SendDlgItemMessage(hWindow,id_Exemples,wm_SetText,0,LongInt(Donnees^.Exemples));
End;

Procedure tDlgMacro.OK (var Msg : tMessage);
(* TEST ET RENVOI DES DONNEES *)
Begin
  if SendDlgItemMessage(hWindow,id_Syntaxe,wm_GetText,SizeOf(Buffer),LongInt(@Buffer)) > 0
     then   (* LA CHAINE DE SYNTAXE N'EST PAS VIDE : ON PEUT RENVOYER LES DONNEES *)
       begin
         if Donnees^.Syntaxe <> Nil
            then
              StrDispose(Donnees^.Syntaxe);
         Donnees^.Syntaxe:=StrNew(Buffer);
         if SendDlgItemMessage(hWindow,id_Utilisation,wm_GetText,SizeOf(Buffer),LongInt(@Buffer)) > 0
            then
              begin
                if Donnees^.Utilisation <> Nil
                   then
                     StrDispose(Donnees^.Utilisation);
                Donnees^.Utilisation:=StrNew(Buffer);
              end;
         if SendDlgItemMessage(hWindow,id_Parametres,wm_GetText,SizeOf(Buffer),LongInt(@Buffer)) > 0
            then
              begin
                if Donnees^.Parametres <> Nil
                   then
                     StrDispose(Donnees^.Parametres);
                Donnees^.Parametres:=StrNew(Buffer);
              end;
         if SendDlgItemMessage(hWindow,id_Exemples,wm_GetText,SizeOf(Buffer),LongInt(@Buffer)) > 0
            then
              begin
                if Donnees^.Exemples <> Nil
                   then
                     StrDispose(Donnees^.Exemples);
                Donnees^.Exemples:=StrNew(Buffer);
              end;
         (* FERMETURE DU DIALOGUE *)
         tDialog.OK(Msg);
       end;
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                             METHODES DE L'OBJET tListeMacros                                           *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tListeMacros.INIT (FenetreParent : pWindowsObject);
(* DEFINITION DU STYLE DE LA BOITE LISTE *)
Begin
  tListBox.INIT(FenetreParent,id_ListeMacros,0,0,200,50);
  Attr.Style:=ws_Child or ws_Visible or ws_Border or ws_VScroll or ws_TabStop or lbs_Notify or lbs_OwnerDrawFixed or
              lbs_Sort or lbs_WantKeyboardInput;
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                          METHODES DE L'OBJET tFenetrePrincipale                                        *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tFenetrePrincipale.INIT;
(* CHARGEMENT DU MENU, INITIALISATION DES CHAMPS, ALLOCATION DES CONTROLES ENFANTS *)
Var c : Array [0..255] of Char;   (* TITRE DE LA FENETRE *)
Begin
  StrCopy(c,'LPJJGlos 2.00 - Glossaire des macros pour le programme LPJJHelp 2.00');
  tWindow.INIT(Nil,c);
  (* CHARGEMENT DU MENU *)
  Attr.Menu:=LoadMenu(hInstance,pChar(id_MenuPrincipal));
  (* INITIALISATION DES CHAMPS *)
  FillChar(ListeFichiers,SizeOf(ListeFichiers),0);
  Separateur:=False;
  NomFichier[0]:=#0;
  Repertoire[0]:=#0;
  Chemin[0]:=#0;
  Modification:=False;
  (* ALLOCATION DE LA BOITE LISTE PRINCIPALE *)
  ListeMacros:=New(pListeMacros,INIT(@Self));
End;

Procedure tFenetrePrincipale.WMCREATE (var Msg : tMessage);
(* PRISE EN CHARGE DU GLISSER-DEPOSER DE FICHIER *)
Begin
  DragAcceptFiles(hWindow,True);
  tWindow.WMCREATE(Msg);
End;

Procedure tFenetrePrincipale.GETWINDOWCLASS (var aWndClass : tWndClass);
(* DEFINITION DE L'ICONE DE CLASSE DE LA FENETRE PRINCIPALE *)
Begin
  tWindow.GETWINDOWCLASS(aWndClass);
  aWndClass.hIcon:=LoadIcon(hInstance,pChar(id_IconeFenetrePrincipale));
End;

Procedure tFenetrePrincipale.AFFICHAGE_TITRE_FENETRE (NomFichierCourant : pChar);
(* CONSTRUCTION DU TITRE DE LA FENETRE AVEC LE NOM DU FICHIER COURANT *)
Begin
  StrCopy(Caption,NomApplication);
  StrCat(Caption,' - [');
  StrCat(Caption,NomFichierCourant);
  StrCat(Caption,']');
  SetCaption(Caption);
End;

Procedure tFenetrePrincipale.MISE_A_JOUR_MENU_FICHIER;
(* MISE A JOUR DE LA LISTE DES FICHIERS PRECEDEMMENT OUVERTS DANS LE MENU Fichier *)
Var i : Integer;                           (* IDENTIFICATEUR DE COMMANDE - INDICE DANS LA LISTE DES FICHIERS *)
    c : Array [0..3] of Char;              (* CHAINE DE CONVERSION *)
    ChaineMenu : Array [0..263] of Char;   (* CHAINE A AJOUTER DANS LE MENU *)
    SousMenu : hMenu;                      (* HANDLE DU MENU Fichier *)
Begin
  SousMenu:=GetSubMenu(Attr.Menu,0);
  (* SUPPRESSION DE LA LISTE DES FICHIERS EXISTANTE *)
  for i:=cm_Fichier1 to (cm_Fichier1 + NbEntreesListeFichiers - 1) do
    DeleteMenu(SousMenu,i,mf_ByCommand);
  (* AJOUT EVENTUEL DU SEPARATEUR *)
  if not Separateur
     then
       begin
         AppendMenu(SousMenu,mf_Separator,0,Nil);
         Separateur:=True;
       end;
  (* AJOUT DE LA NOUVELLE LISTE DE FICHIERS *)
  for i:=1 to NbEntreesListeFichiers do
    if StrLen(ListeFichiers[i]) > 0
       then   (* ENTREE NON VIDE *)
         begin
           StrCopy(ChaineMenu,'&');
           Str(i,c);
           StrCat(ChaineMenu,c);
           StrCat(ChaineMenu,' ');
           StrCat(ChaineMenu,ListeFichiers[i]);
           AppendMenu(SousMenu,mf_String,cm_Fichier1 + i - 1,ChaineMenu);
         end
       else   (* FIN DE BOUCLE *)
         i:=NbEntreesListeFichiers;
  (* AFFICHAGE DU MENU MODIFIE *)
  DrawMenuBar(hWindow);
End;

Procedure tFenetrePrincipale.CHARGEMENT_LISTE_FICHIERS;
(* AJOUT DE LA LISTE DES 9 DERNIERS FICHIERS UTILISES AU BAS DU MENU Fichier (SE TROUVE DANS LPJJGlos.ini) *)
Var i : Byte;                                 (* INDICE DANS LE TABLEAU DES NOMS DE FICHIERS *)
    NomSection : Array [0..80] of Char;       (* NOM DE LA SECTION DANS LPJJGlos.ini *)
    NomEntree : Array [0..80] of Char;        (* NOM DE L'ENTREE A L'INTERIEUR DE LA SECTION *)
    Defaut : Array [0..1] of Char;            (* CHAINE PAR DEFAUT *)
    NomFichierIni : Array [0..260] of Char;   (* NOM DU FICHIER INI *)
Begin
  StrCopy(NomSection,'Liste des derniers fichiers ouverts');
  Defaut[0]:=#0;
  StrCopy(NomFichierIni,'LPJJGlos.ini');
  for i:=1 to NbEntreesListeFichiers do
    begin
      Str(i,NomEntree);
      if GetPrivateProfileString(NomSection,NomEntree,Defaut,ListeFichiers[i],SizeOf(ListeFichiers[i]),NomFichierIni) = 0
         then   (* FIN DE BOUCLE *)
           i:=NbEntreesListeFichiers;
    end;
  if StrLen(ListeFichiers[1]) > 0
     then   (* IL Y A AU MOINS UN NOM DE FICHIER A AJOUTER AU MENU *)
       MISE_A_JOUR_MENU_FICHIER;
End;

Procedure tFenetrePrincipale.SAUVEGARDE_LISTE_FICHIERS;
(* SAUVEGARDE DE LA LISTE DES 9 DERNIERS FICHIERS UTILISES AU BAS DU MENU Fichier DANS LPJJGlos.ini *)
Var i : Byte;                                 (* INDICE DANS LE TABLEAU DES NOMS DE FICHIERS *)
    NomSection : Array [0..80] of Char;       (* NOM DE LA SECTION DANS LPJJGlos.ini *)
    NomEntree : Array [0..80] of Char;        (* NOM DE L'ENTREE A L'INTERIEUR DE LA SECTION *)
    NomFichierIni : Array [0..260] of Char;   (* NOM DU FICHIER INI *)
Begin
  StrCopy(NomSection,'Liste des derniers fichiers ouverts');
  StrCopy(NomFichierIni,'LPJJGlos.ini');
  for i:=1 to NbEntreesListeFichiers do
    if StrLen(ListeFichiers[i]) > 0
       then   (* ENTREE NON VIDE *)
         begin
           Str(i,NomEntree);
           WritePrivateProfileString(NomSection,NomEntree,ListeFichiers[i],NomFichierIni);
         end
       else   (* FIN DE BOUCLE *)
         i:=NbEntreesListeFichiers;
End;

Procedure tFenetrePrincipale.AJOUT_LISTE_FICHIERS (NomFichierCourant : pChar);
(* INSERTION D'UN NOM DE FICHIER DANS LA LISTE DES FICHIERS PRECEDEMMENT OUVERTS *)
Var i, j : Byte;   (* INDICES DANS LA LISTE DES FICHIERS *)
Begin
  (* RECHERCHE DU NOM FICHIER DANS LA LISTE *)
  i:=1;
  j:=0;
  for i:=1 to NbEntreesListeFichiers do
    if StrComp(NomFichierCourant,ListeFichiers[i]) = 0
       then   (* LE FICHIER EXISTE DEJA *)
         begin
           j:=i;
           i:=NbEntreesListeFichiers;
         end;
  (* INSERTION DU FICHIER DANS LA LISTE *)
  if j = 0
     then
       j:=NbEntreesListeFichiers;
  if j > 1
     then
       begin
         for i:=j downto 2 do
           StrCopy(ListeFichiers[i],ListeFichiers[i - 1]);
         StrCopy(ListeFichiers[1],NomFichierCourant);
       end;
  MISE_A_JOUR_MENU_FICHIER;
End;

Procedure tFenetrePrincipale.SETUPWINDOW;
(* CHARGEMENT DU FICHIER PASSE COMME PARAMETRE - AFFICHAGE DE LA FENETRE EN PLEIN ECRAN *)
Var c : Array [0..260] of Char;   (* NOM DU FICHIER DEPOSE *)
    Position : pChar;             (* POSITION DU NOM DE FICHIER DANS LE CHEMIN COMPLET *)
Begin
  tWindow.SETUPWINDOW;
  (* CHARGEMENT DE LA LISTE DES FICHIERS PRECEDEMMENT OUVERTS *)
  CHARGEMENT_LISTE_FICHIERS;
  (* CHARGEMENT DU FICHIER PASSE COMME PARAMETRE *)
  if ParamCount > 0
     then
       begin
         StrPCopy(c,ParamStr(1));
         (* EXTRACTION DU NOM DE FICHIER *)
         StrCopy(Chemin,c);
         GetFileTitle(c,NomFichier,SizeOf(NomFichier));
         if StrLen(NomFichier) < StrLen(c)
            then   (* EXTRACTION DU REPERTOIRE COURANT *)
              begin
                Position:=StrPos(c,NomFichier);
                if Position <> Nil
                   then
                     Position[0]:=#0;
                StrCopy(Repertoire,c);
              end;
         if CHARGEMENT_MACROS
            then
              begin
                AFFICHAGE_TITRE_FENETRE(Chemin);
                AJOUT_LISTE_FICHIERS(Chemin);
              end;
       end;
  (* AFFICHAGE DE LA FENETRE EN PLEIN ECRAN *)
  PostMessage(hWindow,wm_SysCommand,sc_Maximize,0);
  (* SELECTION DU 1ER LEMENT DE LA BOITE LISTE *)
  SendDlgItemMessage(hWindow,id_ListeMacros,lb_SetCurSel,0,0);
End;

Procedure tFenetrePrincipale.WMSIZE (var Msg : tMessage);
(* ADAPTATION DE LA TAILLE DE LA BOITE LISTE A LA ZONE CLIENT DE LA FENETRE *)
Var r : tRect;   (* COORDONNEES DE LA ZONE CLIENT *)
Begin
  GetClientRect(hWindow,r);
  MoveWindow(ListeMacros^.hWindow,0,0,r.Right,r.Bottom,True);
  (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
  SetFocus(ListeMacros^.hWindow);
End;

Procedure tFenetrePrincipale.WMMEASUREITEM (var Msg : tMessage);
(* DETERMINATION DE LA HAUTEUR D'UNE LIGNE DE LA BOITE LISTE *)
Var DC : hDC;         (* CONTEXTE D'AFFICHAGE *)
    Taille : tSize;   (* RESULTAT DE LA FONCTION GetTextExtentPoint *)
Begin
  DC:=GetDC(ListeMacros^.hWindow);
  GetTextExtentPoint(DC,'(',1,Taille);
  tMeasureItemStruct(Pointer(Msg.lParam)^).ItemHeight:=Taille.cy + 2;
  ReleaseDC(ListeMacros^.hWindow,DC);
End;

Procedure tFenetrePrincipale.WMDRAWITEM (var Msg : tMessage);
(* DESSIN D'UN ELEMENT DE LA BOITE LISTE *)
Var AncienPinceau, Pinceau : hBrush;         (* ANCIEN ET NOUVEAU PINCEAU *)
    AncienCrayon, Crayon : hPen;             (* ANCIEN ET NOUVEAU CRAYON (POINTILLE) *)
    AncienneFonte, Fonte : hFont;            (* ANCIENNE ET NOUVELLE FONTE *)
    AncienModeFond : Integer;                (* MODE INITIAL DE TRAITEMENT DE LA COULEUR DE FOND POUR L'AFFICHAGE DE TEXTE *)
    AncienneCouleur, Couleur : tColorRef;    (* ANCIENNE ET NOUVELLE COULEUR DU TEXTE OU DU FOND *)
Begin
  with tDrawItemStruct(Pointer(Msg.lParam)^) do
    begin
      (* DESSIN DU FOND *)
      if (ItemState and ods_Selected) = ods_Selected
         then
           Couleur:=GetSysColor(color_HighLight)
         else
           Couleur:=GetSysColor(color_Window);
      Pinceau:=CreateSolidBrush(Couleur);
      AncienPinceau:=SelectObject(hDC,Pinceau);
      FillRect(hDC,rcItem,Pinceau);
      SelectObject(hDC,AncienPinceau);
      DeleteObject(Pinceau);
      (* DESSIN DU RECTANGLE SYMBOLISANT LE FOCUS *)
      if (ItemState and ods_Focus) = ods_Focus
         then
           begin
             if (ItemState and ods_Selected) = ods_Selected
                then
                  Couleur:=GetSysColor(color_WindowText)
                else
                  Couleur:=GetSysColor(color_HighLightText);
             Crayon:=CreatePen(ps_Solid,0,Couleur);
             AncienCrayon:=SelectObject(hDC,Crayon);
             with rcItem do
               begin
                 MoveTo(hDC,Left,Top); LineTo(hDC,Right - 1,Top);
                 MoveTo(hDC,Right - 1,Top); LineTo(hDC,Right - 1,Bottom - 1);
                 MoveTo(hDC,Left,Top); LineTo(hDC,Left,Bottom - 1);
                 MoveTo(hDC,Left,Bottom - 1); LineTo(hDC,Right - 1,Bottom - 1);
               end;
             SelectObject(hDC,AncienCrayon);
             DeleteObject(Crayon);
           end;
      (* DESSIN DU CONTENU *)
      if pMacro(ItemData) <> Nil
         then
           begin
             AncienModeFond:=SetBkMode(hDC,Transparent);
             if (ItemState and ods_Selected) = ods_Selected
                then
                  Couleur:=GetSysColor(color_HighLightText)
                else
                  Couleur:=GetSysColor(color_WindowText);
             AncienneCouleur:=SetTextColor(hDC,Couleur);
             TextOut(hDC,rcItem.Left + 3,rcItem.Top,pMacro(ItemData)^.Syntaxe,StrLen(pMacro(ItemData)^.Syntaxe));
             SetBkMode(hDC,AncienModeFond);
             SetTextColor(hDC,AncienneCouleur);
           end;
    end;
End;

Procedure tFenetrePrincipale.WMCOMPAREITEM (var Msg : tMessage);
(* COMPARAISON DE 2 ELEMENTS DE LA BOITE LISTE EN VUE DU TRI *)
Var pTIS : pCompareItemStruct;   (* ADRESSE DES DONNEES A COMPARER *)
    p1, p2 : pMacro;             (* DONNEES A COMPARER *)
    Resultat : Integer;          (* RESULTAT DE LA COMPARAISON *)
Begin
  (* DETERMINATION DE L'ADRESSE DES DONNEES A COMPARER *)
  pTIS:=pCompareItemStruct(Msg.lParam);
  p1:=pMacro(pTIS^.ItemData1);
  p2:=pMacro(pTIS^.ItemData2);
  (* COMPARAISON ET RENVOI DU RESULTAT *)
  Resultat:=StrComp(p1^.Syntaxe,p2^.Syntaxe);
  if Resultat < 0
     then
       Msg.Result:=-1
     else
       if Resultat > 0
          then
            Msg.Result:=1
          else
            Msg.Result:=0;
End;

Procedure tFenetrePrincipale.CMMACROAJOUTER (var Msg : tMessage);
(* AJOUT D'UNE MACRO DANS LA LISTE *)
Var p : pMacro;                      (* DONNEES A STOCKER DANS LA BOITE LISTE *)
    Index : Word;                    (* INDEX DE L'ELEMENT AJOUTE DANS LA BOITE LISTE *)
    Titre : Array [0..25] of Char;   (* TITRE DE LA BOITE A MESSAGES *)
    Texte : Array [0..50] of Char;   (* TEXTE DE LA BOITE A MESSAGES *)
Begin
  New(p);
  if p <> Nil
     then
       begin
         FillChar(p^,SizeOf(p^),0);
         if Application^.EXECDIALOG(New(pDlgMacro,INIT(@Self,p))) = id_OK
            then
              begin
                Index:=SendDlgItemMessage(hWindow,id_ListeMacros,lb_AddString,0,LongInt(p));
                (* SELECTION DU NOUVEL ELEMENT *)
                SendDlgItemMessage(hWindow,id_ListeMacros,lb_SetCurSel,Index,0);
                Modification:=True;
              end
            else
              Dispose(p);
       end
     else   (* MEMOIRE INSUFFISANTE *)
       begin
         StrCopy(Titre,'Erreur');
         StrCopy(Texte,'Mmoire insuffisante');
         MessageBox(hWindow,Texte,Titre,mb_IconHand or mb_Ok);
       end;
  (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
  SetFocus(ListeMacros^.hWindow);
End;

Procedure tFenetrePrincipale.CMMACROMODIFIER (var Msg : tMessage);
(* MODIFICATION DE LA MACRO COURANTE *)
Var Index : Word;   (* INDEX DE L'ELEMENT A MODIFIER *)
    p : pMacro;     (* DONNEES A MODIFIER *)
Begin
  Index:=SendDlgItemMessage(hWindow,id_ListeMacros,lb_GetCurSel,0,0);
  if Index <> Word(lb_Err)
     then
       begin
         SendDlgItemMessage(hWindow,id_ListeMacros,lb_GetText,Index,LongInt(@p));
         if Application^.EXECDIALOG(New(pDlgMacro,INIT(@Self,p))) = id_OK
            then   (* MISE A JOUR DE L'AFFICHAGE DE LA BOITE LISTE *)
              begin
                InvalidateRect(ListeMacros^.hWindow,Nil,True);
                UpdateWindow(ListeMacros^.hWindow);
                Modification:=True;
              end;
       end;
  (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
  SetFocus(ListeMacros^.hWindow);
End;

Procedure tFenetrePrincipale.CMMACROSUPPRIMER (var Msg : tMessage);
(* SUPPRESSION DE LA MACRO COURANTE *)
Var Index : Word;                     (* INDEX DE L'ELEMENT A SUPPRIMER *)
    p : pMacro;                       (* DONNEES A SUPPRIMER *)
    Titre : Array [0..40] of Char;    (* TITRE DU MESSAGE DE CONFIRMATION *)
    Texte : Array [0..255] of Char;   (* TEXTE DU MESSAGE DE CONFIRMATION *)
    c : Array [0..255] of Char;       (* LIBELLE DE LA MACRO *)
    FinLibelle : pChar;               (* POINTE SUR LA FIN DU LIBELLE DE LA MACRO *)
Begin
  Index:=SendDlgItemMessage(hWindow,id_ListeMacros,lb_GetCurSel,0,0);
  if Index <> Word(lb_Err)
     then
       begin
         SendDlgItemMessage(hWindow,id_ListeMacros,lb_GetText,Index,LongInt(@p));
         (* MESSAGE DE CONFIRMATION *)
         StrCopy(Titre,'Confirmation');
         StrCopy(Texte,'Supprimer la macro'#10#13);
         (* CHARGEMENT DU LIBELLE DE LA MACRO *)
         StrCopy(c,p^.Syntaxe);
         FinLibelle:=StrPos(c,'(');
         if FinLibelle <> Nil
            then
              FinLibelle[0]:=#0;
         StrCat(Texte,c);
         StrCat(Texte,' ?');
         if MessageBox(hWindow,Texte,Titre,mb_YesNo or mb_IconQuestion) = id_Yes
            then
              begin
                SendDlgItemMessage(hWindow,id_ListeMacros,lb_DeleteString,Index,0);
                (* SELECTION DE L'ELEMENT SUIVANT *)
                if Index = SendDlgItemMessage(hWindow,id_ListeMacros,lb_GetCount,0,0)
                   then
                     Dec(Index);
                SendDlgItemMessage(hWindow,id_ListeMacros,lb_SetCurSel,Index,0);
                Modification:=True;
              end;
       end;
  (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
  SetFocus(ListeMacros^.hWindow);
End;

Procedure tFenetrePrincipale.WMCOMMAND (var Msg : tMessage);
(* INTERCEPTION DU DOUBLE CLIC SUR UN ELEMENT DE LA BOITE LISTE - CHOIX D'UN FICHIER DEJA OUVERT PRECEDEMMENT *)
Var c : Array [0..260] of Char;   (* CHEMIN COMPLET D'ACCES AU FICHIER *)
    Position : pChar;             (* POSITION DU NOM DE FICHIER DANS LE CHEMIN COMPLET *)
Begin
  if (Msg.wParam = id_ListeMacros) and (HiWord(Msg.lParam) = lbn_DblClk)
     then
       CMMACROMODIFIER(Msg)
     else
       if (Msg.wParam >= cm_Fichier1) and (Msg.wParam < (cm_Fichier1 + NbEntreesListeFichiers))
          then
            begin
              if PREPARATION_NOUVELLES_DONNEES
                 then
                   begin
                     StrCopy(c,ListeFichiers[Msg.wParam - cm_Fichier1 + 1]);
                     (* EXTRACTION DU NOM DE FICHIER *)
                     StrCopy(Chemin,c);
                     GetFileTitle(c,NomFichier,SizeOf(NomFichier));
                     if StrLen(NomFichier) < StrLen(c)
                        then   (* EXTRACTION DU REPERTOIRE COURANT *)
                          begin
                            Position:=StrPos(c,NomFichier);
                            if Position <> Nil
                               then
                                 Position[0]:=#0;
                            StrCopy(Repertoire,c);
                          end;
                     (* CHARGEMENT DU FICHIER *)
                     if CHARGEMENT_MACROS
                        then
                          begin
                            AFFICHAGE_TITRE_FENETRE(Chemin);
                            AJOUT_LISTE_FICHIERS(Chemin);
                          end;
                   end;
            end
          else
            tWindow.WMCOMMAND(Msg);
End;

Procedure tFenetrePrincipale.WMDELETEITEM (var Msg : tMessage);
(* DESTRUCTION D'UNE DONNEE CREEE DANS LA BOITE LISTE *)
Var pDIS : pDeleteItemStruct;   (* CARACTERISTIQUES DE LA DONNEE A DETRUIRE *)
    p : pMacro;                 (* DONNEE STOCKEE *)
Begin
  (* DETERMINATION DE L'ADRESSE DE LA DONNEE A DETRUIRE *)
  pDIS:=pDeleteItemStruct(Msg.lParam);
  p:=pMacro(pDIS^.ItemData);
  (* DESTRUCTION DES CHAINES *)
  if p^.Syntaxe <> Nil
     then
       StrDispose(p^.Syntaxe);
  if p^.Utilisation <> Nil
     then
       StrDispose(p^.Utilisation);
  if p^.Parametres <> Nil
     then
       StrDispose(p^.Parametres);
  if p^.Exemples <> Nil
     then
       StrDispose(p^.Exemples);
  (* DESTRUCTION DE L'ENREGISTREMENT *)
  Dispose(p);
End;

Function tFenetrePrincipale.CHARGEMENT_MACROS : Boolean;
(* CHARGEMENT DES MACROS DU FICHIER CHOISI DANS LA BOITE LISTE PRINCIPALE *)
Var AncienCurseur : hCursor;         (* ANCIEN CURSEUR *)
    HandleFichier : Integer;         (* HANDLE DU FICHIER *)
    NbBytesLus : Integer;            (* NOMBRE DE BYTES LUS DANS LE FICHIER LORS DE LA DERNIERE OPERATION *)
    OkOuverture : Boolean;           (* RESULTAT DE L'OUVERTURE DU FICHIER *)
    OkLecture : Boolean;             (* RESULTAT DE LA LECTURE DU FICHIER *)
    FinFichier : Boolean;            (* INDIQUE QUE LA FIN DE FICHIER EST ATTEINTE *)
    OkAllocation : Boolean;          (* RESULTAT DE L'ALLOCATION DE LA MACRO *)
    OkFermeture : Boolean;           (* RESULTAT DE LA FERMETURE DU FICHIER *)
    Taille : SmallWord;              (* TAILLE DE LA STRUCTURE QUI VA SUIVRE DANS LE FICHIER *)
    p : pMacro;                      (* DONNEES A AJOUTER DANS LA BOITE LISTE *)
    Index : Word;                    (* INDEX DE L'ELEMENT AJOUTE DANS LA BOITE LISTE *)
    Titre : Array [0..25] of Char;   (* TITRE DE LA BOITE A MESSAGES *)
    Texte : Array [0..80] of Char;   (* TEXTE DE LA BOITE A MESSAGES *)
Begin
  AncienCurseur:=SetCursor(LoadCursor(0,idc_Wait));
  OkOuverture:=OUVERTURE_FICHIER(Chemin,of_ReadWrite or of_Share_Exclusive,HandleFichier);
  if OkOuverture
     then
       begin
         OkLecture:=True;
         FinFichier:=False;
         OkAllocation:=True;
         repeat
           (* ALLOCATION DE L'ELEMENT SUIVANT A INSERER DANS LA BOITE LISTE *)
           New(p);
           if p <> Nil
              then
                begin
                  FillChar(p^,SizeOf(p^),0);
                  (* TAILLE DE LA SYNTAXE *)
                  NbBytesLus:=LECTURE_FICHIER(HandleFichier,pChar(@Taille),SizeOf(Taille));
                  if NbBytesLus = -1
                     then
                       OkLecture:=False
                     else
                       if NbBytesLus < SizeOf(Taille)
                          then
                            FinFichier:=True;
                  (* SYNTAXE *)
                  if OkLecture and not FinFichier
                     then
                       begin
                         GetMem(p^.Syntaxe,Taille);
                         NbBytesLus:=LECTURE_FICHIER(HandleFichier,p^.Syntaxe,Taille);
                         if NbBytesLus = -1
                            then
                              OkLecture:=False
                            else
                              if NbBytesLus < Taille
                                 then
                                   FinFichier:=True;
                       end;
                  (* TAILLE DE L'UTILISATION *)
                  if OkLecture and not FinFichier
                     then
                       begin
                         NbBytesLus:=LECTURE_FICHIER(HandleFichier,pChar(@Taille),SizeOf(Taille));
                         if NbBytesLus = -1
                            then
                              OkLecture:=False
                            else
                              if NbBytesLus < SizeOf(Taille)
                                 then
                                   FinFichier:=True;
                       end;
                  (* UTILISATION *)
                  if OkLecture and (not FinFichier) and (Taille <> 0)
                     then
                       begin
                         GetMem(p^.Utilisation,Taille);
                         NbBytesLus:=LECTURE_FICHIER(HandleFichier,p^.Utilisation,Taille);
                         if NbBytesLus = -1
                            then
                              OkLecture:=False
                            else
                              if NbBytesLus < Taille
                                 then
                                   FinFichier:=True;
                       end;
                  (* TAILLE DES PARAMETRES *)
                  if OkLecture and not FinFichier
                     then
                       begin
                         NbBytesLus:=LECTURE_FICHIER(HandleFichier,pChar(@Taille),SizeOf(Taille));
                         if NbBytesLus = -1
                            then
                              OkLecture:=False
                            else
                              if NbBytesLus < SizeOf(Taille)
                                 then
                                   FinFichier:=True;
                       end;
                  (* PARAMETRES *)
                  if OkLecture and (not FinFichier) and (Taille <> 0)
                     then
                       begin
                         GetMem(p^.Parametres,Taille);
                         NbBytesLus:=LECTURE_FICHIER(HandleFichier,p^.Parametres,Taille);
                         if NbBytesLus = -1
                            then
                              OkLecture:=False
                            else
                              if NbBytesLus < Taille
                                 then
                                   FinFichier:=True;
                       end;
                  (* TAILLE DES EXEMPLES *)
                  if OkLecture and not FinFichier
                     then
                       begin
                         NbBytesLus:=LECTURE_FICHIER(HandleFichier,pChar(@Taille),SizeOf(Taille));
                         if NbBytesLus = -1
                            then
                              OkLecture:=False
                            else
                              if NbBytesLus < SizeOf(Taille)
                                 then
                                   FinFichier:=True;
                       end;
                  (* EXEMPLES *)
                  if OkLecture and (not FinFichier) and (Taille <> 0)
                     then
                       begin
                         GetMem(p^.Exemples,Taille);
                         NbBytesLus:=LECTURE_FICHIER(HandleFichier,p^.Exemples,Taille);
                         if NbBytesLus = -1
                            then
                              OkLecture:=False
                            else
                              if NbBytesLus < Taille
                                 then
                                   FinFichier:=True;
                       end;
                  (* AJOUT DANS LA BOITE LISTE *)
                  if OkLecture and not FinFichier
                     then
                       begin
                         Index:=SendDlgItemMessage(hWindow,id_ListeMacros,lb_AddString,0,LongInt(p));
                         (* SELECTION DU NOUVEL ELEMENT *)
                         SendDlgItemMessage(hWindow,id_ListeMacros,lb_SetCurSel,Index,0);
                       end
                     else   (* DESALLOCATION DE L'ELEMENT *)
                       begin
                         if p^.Syntaxe <> Nil
                            then
                              FreeMem(p^.Syntaxe,StrLen(p^.Syntaxe) + 1);
                         if p^.Utilisation <> Nil
                            then
                              FreeMem(p^.Utilisation,StrLen(p^.Utilisation) + 1);
                         if p^.Parametres <> Nil
                            then
                              FreeMem(p^.Parametres,StrLen(p^.Parametres) + 1);
                         if p^.Exemples <> Nil
                            then
                              FreeMem(p^.Exemples,StrLen(p^.Exemples) + 1);
                         Dispose(p);
                       end;
                end
              else   (* MEMOIRE INSUFFISANTE *)
                OkAllocation:=False;
         until FinFichier or (not OkAllocation) or (not OkLecture);
         OkFermeture:=FERMETURE_FICHIER(HandleFichier);
       end;
  SetCursor(AncienCurseur);
  (* MESSAGE D'ERREUR EVENTUEL *)
  if not OkOuverture
     then
       StrCopy(Texte,'Impossible d''ouvrir le fichier')
     else
       if not OkLecture
          then
            StrCopy(Texte,'Erreur de lecture ou structure du fichier incorrecte')
          else
            if not OkFermeture
               then
                 StrCopy(Texte,'Erreur lors de la fermeture du fichier')
               else
                 if not OkAllocation
                    then
                      StrCopy(Texte,'Mmoire insuffisante');
  if (not OkOuverture) or (not OkLecture) or (not OkFermeture) or (not OkAllocation)
     then
       begin
         StrCopy(Titre,'Erreur');
         MessageBox(hWindow,Texte,Titre,mb_IconExclamation or mb_Ok);
       end;
  (* RESULTAT DE LA FONCTION *)
  CHARGEMENT_MACROS:=OkOuverture and OkLecture and OkFermeture and OkAllocation;
End;

Function tFenetrePrincipale.SAUVEGARDE_MACROS (Nb : Word) : Boolean;
(* SAUVEGARDE DES MACROS DE LA BOITE LISTE PRINCIPALE DANS UN FICHIER *)
Var AncienCurseur : hCursor;         (* ANCIEN CURSEUR *)
    HandleFichier : Integer;         (* HANDLE DU FICHIER *)
    NbBytesEcrits : Integer;         (* NOMBRE DE BYTES ECRITS DANS LE FICHIER LORS DE LA DERNIERE OPERATION *)
    OkCreation : Boolean;            (* RESULTAT DE LA CREATION DU FICHIER *)
    OkEcriture : Boolean;            (* RESULTAT DE L'ECRITURE DANS LE FICHIER *)
    OkFermeture : Boolean;           (* RESULTAT DE LA FERMETURE DU FICHIER *)
    Taille : SmallWord;              (* TAILLE DE LA STRUCTURE QUI VA SUIVRE DANS LE FICHIER *)
    p : pMacro;                      (* DONNEES D'UNE MACRO A SAUVEGARDER *)
    Index : Word;                    (* INDEX DE L'ELEMENT A SAUVEGARDER *)
    Titre : Array [0..25] of Char;   (* TITRE DE LA BOITE A MESSAGES *)
    Texte : Array [0..80] of Char;   (* TEXTE DE LA BOITE A MESSAGES *)
Begin
  AncienCurseur:=SetCursor(LoadCursor(0,idc_Wait));
  OkCreation:=CREATION_FICHIER(Chemin,0,HandleFichier);
  if OkCreation
     then
       begin
         OkEcriture:=True;
         Index:=0;
         while (Index < Nb) and OkEcriture do
           begin
             SendDlgItemMessage(hWindow,id_ListeMacros,lb_GetText,Index,LongInt(@p));
             (* TAILLE DE LA SYNTAXE *)
             Taille:=StrLen(p^.Syntaxe) + 1;
             NbBytesEcrits:=ECRITURE_FICHIER(HandleFichier,pChar(@Taille),SizeOf(Taille));
             OkEcriture:=(NbBytesEcrits <> -1);
             (* SYNTAXE *)
             if OkEcriture
                then
                  begin
                    NbBytesEcrits:=ECRITURE_FICHIER(HandleFichier,p^.Syntaxe,Taille);
                    OkEcriture:=(NbBytesEcrits <> -1);
                  end;
             (* TAILLE DE L'UTILISATION *)
             if OkEcriture
                then
                  begin
                    if p^.Utilisation <> Nil
                       then
                         Taille:=StrLen(p^.Utilisation) + 1
                       else
                         Taille:=0;
                    NbBytesEcrits:=ECRITURE_FICHIER(HandleFichier,pChar(@Taille),SizeOf(Taille));
                    OkEcriture:=(NbBytesEcrits <> -1);
                  end;
             (* UTILISATION *)
             if OkEcriture and (p^.Utilisation <> Nil)
                then
                  begin
                    NbBytesEcrits:=ECRITURE_FICHIER(HandleFichier,p^.Utilisation,Taille);
                    OkEcriture:=(NbBytesEcrits <> -1);
                  end;
             (* TAILLE DES PARAMETRES *)
             if OkEcriture
                then
                  begin
                    if p^.Parametres <> Nil
                       then
                         Taille:=StrLen(p^.Parametres) + 1
                       else
                         Taille:=0;
                    NbBytesEcrits:=ECRITURE_FICHIER(HandleFichier,pChar(@Taille),SizeOf(Taille));
                    OkEcriture:=(NbBytesEcrits <> -1);
                  end;
             (* PARAMETRES *)
             if OkEcriture and (p^.Parametres <> Nil)
                then
                  begin
                    NbBytesEcrits:=ECRITURE_FICHIER(HandleFichier,p^.Parametres,Taille);
                    OkEcriture:=(NbBytesEcrits <> -1);
                  end;
             (* TAILLE DES EXEMPLES *)
             if OkEcriture
                then
                  begin
                    if p^.Exemples <> Nil
                       then
                         Taille:=StrLen(p^.Exemples) + 1
                       else
                         Taille:=0;
                    NbBytesEcrits:=ECRITURE_FICHIER(HandleFichier,pChar(@Taille),SizeOf(Taille));
                    OkEcriture:=(NbBytesEcrits <> -1);
                  end;
             (* EXEMPLES *)
             if OkEcriture and (p^.Exemples <> Nil)
                then
                  begin
                    NbBytesEcrits:=ECRITURE_FICHIER(HandleFichier,p^.Exemples,Taille);
                    OkEcriture:=(NbBytesEcrits <> -1);
                  end;
             Inc(Index);
           end;
         OkFermeture:=FERMETURE_FICHIER(HandleFichier);
       end;
  SetCursor(AncienCurseur);
  (* MESSAGE D'ERREUR EVENTUEL *)
  if not OkCreation
     then
       StrCopy(Texte,'Cration du fichier impossible')
     else
       if not OkEcriture
          then
            StrCopy(Texte,'Erreur lors de l''criture dans le fichier')
          else
            if not OkFermeture
               then
                 StrCopy(Texte,'Erreur lors de la fermeture du fichier');
  if (not OkCreation) or (not OkEcriture) or (not OkFermeture)
     then
       begin
         StrCopy(Titre,'Erreur');
         MessageBox(hWindow,Texte,Titre,mb_IconExclamation or mb_Ok);
       end;
  (* RESULTAT DE LA FONCTION *)
  SAUVEGARDE_MACROS:=OkCreation and OkEcriture and OkFermeture;
End;

Function tFenetrePrincipale.PREPARATION_NOUVELLES_DONNEES : Boolean;
(* SAUVEGARDE EVENTUELLE DES DONNEES EN COURS AVANT CHARGEMENT D'UN NOUVEAU FICHIER *)
Var Nb : Word;                        (* NOMBRE D'ELEMENTS DE LA BOITE LISTE *)
    Titre : Array [0..80] of Char;    (* TITRE DE LA BOITE A MESSAGES *)
    Texte : Array [0..255] of Char;   (* TEXTE DE LA BOITE A MESSAGES *)
    Void : tMessage;                  (* MESSAGE INUTILISE *)
    Resultat : Boolean;               (* RESULTAT RENVOYE PAR LA FONCTION *)
Begin
  if Modification
     then
       begin
         Nb:=SendDlgItemMessage(hWindow,id_ListeMacros,lb_GetCount,0,0);
         if (Nb <> 0) and (Nb <> Word(lb_Err))
            then   (* LA LISTE N'EST PAS VIDE : ENREGISTREMENT DES DONNEES *)
              begin
                StrCopy(Titre,'Fichier courant non sauvegard');
                StrCopy(Texte,'Dsirez-vous sauvegarder les donnes en cours ?');
                case MessageBox(hWindow,Texte,Titre,mb_IconQuestion or mb_YesNoCancel) of
                  id_Yes : Resultat:=CMFICHIERENREGISTRER(Void);
                  id_No : Resultat:=True;
                  id_Cancel : Resultat:=False;
                end;
              end
            else
              Resultat:=True;
       end
     else
       Resultat:=True;
  if Resultat
     then   (* VIDANGE COMPLETE DE LA BOITE LISTE *)
       SendDlgItemMessage(hWindow,id_ListeMacros,lb_ResetContent,0,0);
  (* VALEUR RENVOYEE PAR LA FONCTION *)
  PREPARATION_NOUVELLES_DONNEES:=Resultat;
End;

Procedure tFenetrePrincipale.WMDROPFILES (var Msg : tMessage);
(* CHARGEMENT D'UN FICHIER DEPOSE SUR LA FENETRE OUVERTE DEPUIS LE GESTIONNAIRE DE FICHIERS *)
Var c : Array [0..260] of Char;   (* NOM DU FICHIER DEPOSE *)
    Position : pChar;             (* POSITION DU NOM DE FICHIER DANS LE CHEMIN COMPLET *)
Begin
  DragQueryFile(tHandle(Msg.wParam),0,c,SizeOf(c));
  DragFinish(tHandle(Msg.wParam));
  if PREPARATION_NOUVELLES_DONNEES
     then
       begin
         (* EXTRACTION DU NOM DE FICHIER *)
         StrCopy(Chemin,c);
         GetFileTitle(c,NomFichier,SizeOf(NomFichier));
         if StrLen(NomFichier) < StrLen(c)
            then   (* EXTRACTION DU REPERTOIRE COURANT *)
              begin
                Position:=StrPos(c,NomFichier);
                if Position <> Nil
                   then
                     Position[0]:=#0;
                StrCopy(Repertoire,c);
              end;
         (* CHARGEMENT DU FICHIER *)
         if CHARGEMENT_MACROS
            then
              begin
                AFFICHAGE_TITRE_FENETRE(Chemin);
                AJOUT_LISTE_FICHIERS(Chemin);
              end;
       end;
  (* PASSAGE DE LA FENETRE A L'AVANT-PLAN *)
  BringWindowToTop(hWindow);
  (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
  SetFocus(ListeMacros^.hWindow);
End;

Procedure tFenetrePrincipale.CMFICHIERNOUVEAU (var Msg : tMessage);
(* DEBUT DE L'ENCODAGE DES DONNEES D'UN NOUVEAU FICHIER *)
Var c : Array [0..255] of Char;   (* TITRE DE LA FENETRE *)
Begin
  if PREPARATION_NOUVELLES_DONNEES
     then   (* LA BOITE LISTE DES MACROS A ETE REINITIALISEE *)
       begin
         (* REINITIALISATION DE LA BARRE DE TITRE *)
         StrCopy(c,'LPJJGlos 2.00 - Glossaire des macros pour le programme LPJJHelp 2.00');
         SetCaption(c);
         (* REINITIALISATION DES CHAMPS *)
         NomFichier[0]:=#0;
         Chemin[0]:=#0;
         Modification:=False;
       end;
  (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
  SetFocus(ListeMacros^.hWindow);
End;

Function tFenetrePrincipale.CMFICHIEROUVRIR (var Msg : tMessage) : Boolean;
(* DIALOGUE WINDOWS D'OUVERTURE DE FICHIER *)
Var fn : tOpenFileName;                      (* INTERFACE AVEC LE DIALOGUE WINDOWS *)
    TitreDialogue : Array [0..80] of Char;   (* TITRE DU DIALOGUE WINDOWS *)
    Filtre : Array [0..255] of Char;         (* CHAINE DE FILTRE *)
    i : Word;                                (* INDEX DANS LA CHAINE DE FILTRE *)
    c : Array [0..260] of Char;              (* CHEMIN COMPLET *)
    Resultat : Boolean;                      (* RESULTAT RENVOYE PAR LA FONCTION *)
Begin
  if PREPARATION_NOUVELLES_DONNEES
     then
       begin
         FillChar(fn,SizeOf(fn),0);
         fn.lStructSize:=SizeOf(fn);
         fn.hWndOwner:=hWindow;
         StrCopy(Filtre,'Glossaires (*.glo)|*.glo|Tous fichiers (*.*)|*.*|');
         for i:=0 to StrLen(Filtre) do
           if Filtre[i] = '|'
              then
                Filtre[i]:=#0;
         fn.lpstrFilter:=Filtre;
         fn.nFilterIndex:=1;
         c[0]:=#0;
         fn.lpstrFile:=c;
         fn.nMaxFile:=SizeOf(c);
         fn.lpstrFileTitle:=NomFichier;
         fn.nMaxFileTitle:=SizeOf(NomFichier);
         fn.lpstrInitialDir:=Repertoire;
         StrCopy(TitreDialogue,'Ouverture de fichier');
         fn.lpstrTitle:=TitreDialogue;
         fn.Flags:=ofn_PathMustExist or ofn_FileMustExist or ofn_HideReadOnly;
         if GetOpenFileName(fn)
            then
              begin
                (* SAUVEGARDE DU REPERTOIRE COURANT (NomFichier A ETE MIS A JOUR) *)
                StrCopy(Chemin,c);
                c[fn.nFileOffset]:=#0;
                StrCopy(Repertoire,c);
                (* CHARGEMENT DU FICHIER *)
                Resultat:=CHARGEMENT_MACROS;
                if Resultat
                   then
                     begin
                       AFFICHAGE_TITRE_FENETRE(Chemin);
                       AJOUT_LISTE_FICHIERS(Chemin);
                     end;
              end
            else
              Resultat:=False;
       end
     else
       Resultat:=False;
  (* VALEUR RENVOYEE PAR LA FONCTION *)
  CMFICHIEROUVRIR:=Resultat;
  (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
  SetFocus(ListeMacros^.hWindow);
End;

Function tFenetrePrincipale.CMFICHIERENREGISTRERSOUS (var Msg : tMessage) : Boolean;
(* DIALOGUE WINDOWS D'ENREGISTREMENT D'UN NOUVEAU FICHIER *)
Var Nb : Word;                               (* NOMBRE DE MACROS A SAUVEGARDER *)
    fn : tOpenFileName;                      (* INTERFACE AVEC LE DIALOGUE WINDOWS *)
    TitreDialogue : Array [0..80] of Char;   (* TITRE DU DIALOGUE WINDOWS *)
    Filtre : Array [0..255] of Char;         (* CHAINE DE FILTRE *)
    i : Word;                                (* INDEX DANS LA CHAINE DE FILTRE *)
    c : Array [0..260] of Char;              (* NOM DU FICHIER (EN ENTREE) / CHEMIN COMPLET (EN SORTIE) *)
    Extension : Array [0..3] of Char;        (* EXTENSION PAR DEFAUT *)
Begin
  Nb:=SendDlgItemMessage(hWindow,id_ListeMacros,lb_GetCount,0,0);
  if (Nb <> 0) and (Nb <> Word(lb_Err))
     then   (* BOITE LISTE NON VIDE *)
       begin
         FillChar(fn,SizeOf(fn),0);
         fn.lStructSize:=SizeOf(fn);
         fn.hWndOwner:=hWindow;
         StrCopy(Filtre,'Glossaires (*.glo)|*.glo|Tous fichiers (*.*)|*.*|');
         for i:=0 to StrLen(Filtre) do
           if Filtre[i] = '|'
              then
                Filtre[i]:=#0;
         fn.lpstrFilter:=Filtre;
         fn.nFilterIndex:=1;
         StrCopy(c,NomFichier);
         fn.lpstrFile:=c;
         fn.nMaxFile:=SizeOf(c);
         fn.lpstrFileTitle:=NomFichier;
         fn.nMaxFileTitle:=SizeOf(NomFichier);
         fn.lpstrInitialDir:=Repertoire;
         StrCopy(TitreDialogue,'Enregistrement des donnes');
         fn.lpstrTitle:=TitreDialogue;
         fn.Flags:=ofn_PathMustExist or ofn_OverwritePrompt or ofn_HideReadOnly;
         StrCopy(Extension,'glo');
         fn.lpstrDefExt:=Extension;
         if GetSaveFileName(fn)
            then
              begin
                (* SAUVEGARDE DU REPERTOIRE COURANT (NomFichier A ETE MIS A JOUR) *)
                StrCopy(Chemin,c);
                c[fn.nFileOffset]:=#0;
                StrCopy(Repertoire,c);
                (* SAUVEGARDE DU FICHIER *)
                Modification:=not SAUVEGARDE_MACROS(Nb);
                CMFICHIERENREGISTRERSOUS:=not Modification;
                if not Modification
                   then
                     begin
                       AFFICHAGE_TITRE_FENETRE(Chemin);
                       AJOUT_LISTE_FICHIERS(Chemin);
                     end;
              end
            else
              CMFICHIERENREGISTRERSOUS:=False;
       end
     else
       CMFICHIERENREGISTRERSOUS:=False;
  (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
  SetFocus(ListeMacros^.hWindow);
End;

Function tFenetrePrincipale.CMFICHIERENREGISTRER (var Msg : tMessage) : Boolean;
(* ENREGISTREMENT DES MACROS DANS UN FICHIER *)
Var Nb : Word;   (* NOMBRE DE MACROS A SAUVEGARDER *)
Begin
  if StrLen(NomFichier) = 0
     then   (* PAS ENCORE DE NOM DE FICHIER *)
       CMFICHIERENREGISTRER:=CMFICHIERENREGISTRERSOUS(Msg)
     else   (* NOM DE FICHIER DEJA DEFINI *)
       begin
         Nb:=SendDlgItemMessage(hWindow,id_ListeMacros,lb_GetCount,0,0);
         if (Nb <> 0) and (Nb <> Word(lb_Err))
            then
              begin
                Modification:=not SAUVEGARDE_MACROS(Nb);
                CMFICHIERENREGISTRER:=not Modification;
              end
            else
              CMFICHIERENREGISTRER:=False;
       end;
  (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
  SetFocus(ListeMacros^.hWindow);
End;

Function tFenetrePrincipale.CANCLOSE : Boolean;
(* CONFIRMATION DE FERMETURE EN CAS DE DONNEES NON SAUVEGARDEES *)
Var Titre : Array [0..40] of Char;    (* TITRE DE LA BOITE A MESSAGES *)
    Texte : Array [0..100] of Char;   (* TEXTE DE LA BOITE A MESSAGES *)
    Void : tMessage;                  (* MESSAGE INUTILISE *)
Begin
  if Modification
     then
       begin
         StrCopy(Titre,'Quitter');
         StrCopy(Texte,'Dsirez-vous enregistrer les modifications ?');
         case MessageBox(hWindow,Texte,Titre,mb_IconQuestion or mb_YesNoCancel) of
           id_Yes : begin
                      CMFICHIERENREGISTRER(Void);
                      CANCLOSE:=not Modification;
                    end;
           id_No : CANCLOSE:=True;
           id_Cancel : begin
                         CANCLOSE:=False;
                         (* ATTRIBUTION DU FOCUS A LA LISTE DES MACROS *)
                         SetFocus(ListeMacros^.hWindow);
                       end;
         end;
       end
     else
       CANCLOSE:=True;
End;

Procedure tFenetrePrincipale.WMDESTROY (var Msg : tMessage);
(* FIN DE LA PRISE EN CHARGE DU GLISSER-DEPOSER DE FICHIER *)
Begin
  DragAcceptFiles(hWindow,False);
  tWindow.WMDESTROY(Msg);
End;

Destructor tFenetrePrincipale.DONE;
(* SAUVEGARDE DE LA LISTE DES DERNIERS FICHIERS OUVERTS DANS LE FICHIER LPJJGlos.ini *)
Begin
  SAUVEGARDE_LISTE_FICHIERS;
  tWindow.DONE;
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                              METHODES DE L'OBJET tProgramme                                            *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tProgramme.INIT (NomProgramme : pChar);
(* REMPLACEMENT DE LA ROUTINE DE GESTION DES ALLOCATIONS DYNAMIQUES *)
Begin
  HeapError:=@ERREUR_ALLOCATION;
  tApplication.INIT(NomProgramme);
End;

Procedure tProgramme.INITINSTANCE;
(* CHARGEMENT DE LA TABLE D'ACCELERATEURS *)
Begin
  tApplication.INITINSTANCE;
  hAccTable:=LoadAccelerators(hInstance,pChar(id_Accelerateurs));
End;

Procedure tProgramme.INITMAINWINDOW;
(* CHOIX DU TYPE DE LA FENETRE PRINCIPALE DE L'APPLICATION *)
Begin
  MainWindow:=New(pFenetrePrincipale,INIT);
End;

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  PROGRAMME PRINCIPAL                                                   *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

BEGIN
  Programme.INIT(NomApplication);
  Programme.RUN;
  Programme.DONE;
END.
